Index: CustomZone.cxx
===================================================================
--- CustomZone.cxx	(revision 20911)
+++ CustomZone.cxx	(working copy)
@@ -63,7 +63,7 @@
 }
 
 
-void CustomZone::addZoneFlagCount(FlagType* flagType, int count)
+void CustomZone::addZoneFlagCount(const FlagType* flagType, int count)
 {
   ZoneFlagMap::iterator it = zoneFlagMap.find(flagType);
   if (it != zoneFlagMap.end()) {
@@ -89,7 +89,7 @@
       if (flag == "good") {
 	FlagSet &fs = Flag::getGoodFlags();
 	for (FlagSet::iterator it = fs.begin(); it != fs.end(); ++it) {
-	  FlagType *f = *it;
+	  const FlagType *f = *it;
 	  if (f->endurance != FlagNormal) { // Null and Team flags
 	    const std::string& qual = getFlagTypeQualifier(f);
 	    if (qual.size() > 0) {
@@ -101,7 +101,7 @@
       else if (flag == "bad") {
 	FlagSet &fs = Flag::getBadFlags();
 	for (FlagSet::iterator it = fs.begin(); it != fs.end(); ++it) {
-	  FlagType *f = *it;
+	  const FlagType *f = *it;
 	  if (f->endurance != FlagNormal) { // Null and Team flags
 	    const std::string& qual = getFlagTypeQualifier(f);
 	    if (qual.size() > 0) {
@@ -111,7 +111,7 @@
 	}
       }
       else {
-	FlagType* f = Flag::getDescFromAbbreviation(flag.c_str());
+	const FlagType* f = Flag::getDescFromAbbreviation(flag.c_str());
 	if (f == Flags::Null) {
 	  logDebugMessage(1,"WARNING: bad flag type: %s\n", flag.c_str());
 	  input.putback('\n');
@@ -150,7 +150,7 @@
     if (flag == "good") {
       FlagSet &fs = Flag::getGoodFlags();
       for (FlagSet::iterator it = fs.begin(); it != fs.end(); ++it) {
-	FlagType *f = *it;
+	const FlagType *f = *it;
 	if (f->endurance != FlagNormal) { // Null and Team flags
 	  addZoneFlagCount(f, count);
 	}
@@ -159,14 +159,14 @@
     else if (flag == "bad") {
       FlagSet &fs = Flag::getBadFlags();
       for (FlagSet::iterator it = fs.begin(); it != fs.end(); ++it) {
-	FlagType *f = *it;
+	const FlagType *f = *it;
 	if (f->endurance != FlagNormal) { // Null and Team flags
 	  addZoneFlagCount(f, count);
 	}
       }
     }
     else {
-      FlagType *f = Flag::getDescFromAbbreviation(flag.c_str());
+      const FlagType *f = Flag::getDescFromAbbreviation(flag.c_str());
       if (f != Flags::Null) {
 	addZoneFlagCount(f, count);
       }
@@ -219,6 +219,7 @@
   worldInfo->addZone( this );
 }
 
+
 void CustomZone::getRandomPoint(float *pt) const
 {
   float x = (float)((bzfrand() * (2.0f * size[0])) - size[0]);
@@ -256,6 +257,7 @@
   return qual;
 }
 
+
 static int checkIntQualifier(char prefix, const std::string& qual)
 {
   if (qual[0] == prefix) {
@@ -270,22 +272,9 @@
 }
 
 
-const std::string& CustomZone::getFlagIdQualifier(int flagId)
+const std::string& CustomZone::getFlagTypeQualifier(const FlagType* flagType)
 {
   static std::string qual;
-  qual = makeIntQualifier('#', flagId);
-  return qual;
-}
-
-int CustomZone::getFlagIdFromQualifier(const std::string& qual)
-{
-  return checkIntQualifier('#', qual);
-}
-
-
-const std::string& CustomZone::getFlagTypeQualifier(FlagType* flagType)
-{
-  static std::string qual;
   if (flagType != NULL) {
     qual = "f";
     qual += flagType->flagAbbv;
@@ -295,7 +284,7 @@
   return qual;
 }
 
-FlagType* CustomZone::getFlagTypeFromQualifier(const std::string& qual)
+const FlagType* CustomZone::getFlagTypeFromQualifier(const std::string& qual)
 {
   if (qual[0] == 'f') {
     return Flag::getDescFromAbbreviation(qual.c_str() + 1);
Index: bzfs.h
===================================================================
--- bzfs.h	(revision 20911)
+++ bzfs.h	(working copy)
@@ -114,6 +114,7 @@
 extern void       dropFlag(FlagInfo& flag, const float dropPos[3]);
 extern void       publicize();
 extern TeamColor  whoseBase(float x, float y, float z);
+extern void       onGlobalChanged(const std::string& name, void*);
 bool defineWorld ( void );
 bool saveWorldCache( const char* file = NULL );
 
@@ -128,7 +129,6 @@
 extern bool	    done;
 extern bool	    gameOver;
 extern TeamInfo	team[NumTeams];
-extern int	     numFlags;
 extern bool	    countdownActive;
 extern int	     countdownDelay;
 extern TimeKeeper      countdownPauseStart;
Index: CustomZone.h
===================================================================
--- CustomZone.h	(revision 20911)
+++ CustomZone.h	(working copy)
@@ -27,7 +27,7 @@
 
 
 typedef std::vector<std::string> QualifierList;
-typedef std::map<FlagType*, int> ZoneFlagMap; // type, count
+typedef std::map<const FlagType*, int> ZoneFlagMap; // type, count
 
 
 class CustomZone : public WorldFileLocation {
@@ -49,12 +49,9 @@
     float getDistToPoint (const float *pos) const;
 
   public:
-    static const std::string& getFlagIdQualifier(int flagId);
-    static int getFlagIdFromQualifier(const std::string&);
+    static const std::string& getFlagTypeQualifier(const FlagType* flagType);
+    static const FlagType* getFlagTypeFromQualifier(const std::string&);
 
-    static const std::string& getFlagTypeQualifier(FlagType* flagType);
-    static FlagType* getFlagTypeFromQualifier(const std::string&);
-
     static const std::string& getFlagSafetyQualifier(int team);
     static int getFlagSafetyFromQualifier(const std::string&);
 
@@ -62,7 +59,7 @@
     static int getPlayerTeamFromQualifier(const std::string&);
 
   private:
-    void addZoneFlagCount(FlagType* flagType, int count);
+    void addZoneFlagCount(const FlagType* flagType, int count);
 
   private:
     ZoneFlagMap zoneFlagMap;
Index: RecordReplay.cxx
===================================================================
--- RecordReplay.cxx	(revision 20911)
+++ RecordReplay.cxx	(working copy)
@@ -1590,9 +1590,9 @@
   int cnt = 0;
   int length = sizeof(u16);
 
-  for (flagIndex = 0; flagIndex < numFlags; flagIndex++) {
-    FlagInfo &flag = *FlagInfo::get(flagIndex);
-    if (flag.exist()) {
+  for (flagIndex = 0; flagIndex < FLAGMGR.size(); flagIndex++) {
+    FlagInfo &flag = *FLAGMGR.getFlag(flagIndex);
+    if (flag.exists()) {
       if ((length + sizeof(u16) + FlagPLen) > MaxPacketLen - 2*sizeof(u16)) {
 	// packet length overflow
 	nboPackUShort(bufStart, cnt);
@@ -2232,7 +2232,7 @@
 
 static bool replaceFlagTypes(ReplayHeader *h)
 {
-  bool replace = false;
+//FIXME  bool replace = false;
   void *buf = h->flags;
   FlagOptionMap headerFlag;
   FlagTypeMap::iterator it;
@@ -2250,6 +2250,9 @@
   // we're done with this
   delete[] h->flags;
 
+/* FIXME - with flexible flags, all must be active
+           FLAGMGR.clear() also clear forbiddenFlags
+
   // See if all of the flags required by the header are currently active
   for (it = FlagType::getFlagMap().begin();
        it != FlagType::getFlagMap().end(); ++it) {
@@ -2275,6 +2278,7 @@
     return true; // flag types were replaced
   }
 
+*/
   return false;  // flag types were not replaced
 }
 
@@ -2339,11 +2343,15 @@
   // Please see the MsgNegotiateFlags code in [bzfs.cxx]
   // to see what it is that we are trying to fake.
 
+  type = type; //FIXME  
+  /*FIXME
+
   if ((clOptions->flagCount[type] > 0) ||
       ((clOptions->numExtraFlags > 0) &&
        !clOptions->flagDisallowed[type])) {
     return true;
   }
+  */
   return false;
 }
 
Index: WorldInfo.cxx
===================================================================
--- WorldInfo.cxx	(revision 20911)
+++ WorldInfo.cxx	(working copy)
@@ -397,7 +397,7 @@
 bool WorldInfo::getFlagDropPoint(const FlagInfo* fi, const float* pos,
 				float* pt) const
 {
-  FlagType* flagType = fi->flag.type;
+  const FlagType* flagType = fi->getFlagType();
   const int team = (int)flagType->flagTeam;
   const bool teamFlag = (team != NoTeam);
 
@@ -407,31 +407,34 @@
     if (entryZones.getClosePoint(safetyQual, pos, pt)) {
       return true;
     }
-  } else {
-    const std::string& idQual =
-      CustomZone::getFlagIdQualifier(fi->getIndex());
-    if (entryZones.getClosePoint(idQual, pos, pt)) {
+  }
+  else {
+    const CustomZone* srcZone = fi->getSourceZone();
+    if (srcZone != NULL) {
+      srcZone->getRandomPoint(pt);
       return true;
     }
+
     const std::string& typeQual =
       CustomZone::getFlagTypeQualifier(flagType);
     if (entryZones.getClosePoint(typeQual, pos, pt)) {
       return true;
     }
   }
+  
   return false;
 }
 
 
 bool WorldInfo::getFlagSpawnPoint(const FlagInfo* fi, float* pt) const
 {
-  FlagType* flagType = fi->flag.type;
+  const FlagType* flagType = fi->getFlagType();
   const int team = (int)flagType->flagTeam;
   const bool teamFlag = (team != NoTeam);
 
-  const std::string& idQual =
-    CustomZone::getFlagIdQualifier(fi->getIndex());
-  if (entryZones.getRandomPoint(idQual, pt)) {
+  const CustomZone* srcZone = fi->getSourceZone();
+  if (srcZone != NULL) {
+    srcZone->getRandomPoint(pt);
     return true;
   }
 
@@ -442,6 +445,7 @@
       return true;
     }
   }
+
   return false;
 }
 
Index: FlagInfo.h
===================================================================
--- FlagInfo.h	(revision 20911)
+++ FlagInfo.h	(working copy)
@@ -18,64 +18,212 @@
 
 /* system headers */
 #include <stdlib.h>
+#include <map>
+#include <set>
+#include <vector>
+#include <string>
 
 /* bzflag common headers */
 #include "Flag.h"
 #include "TimeKeeper.h"
 
+
 /** FlagInfo describes a flag as it pertains to the world.
  */
+ 
+class CustomZone;
+class EntryZones;
+ 
+ 
 class FlagInfo {
-public:
 
-  FlagInfo();
+  friend class FlagManager;
 
-  void setRequiredFlag(FlagType *desc);
-  void addFlag();
-  void *pack(void *buf, bool hide = false);
-  void dropFlag(float pos[3], float landingPos[3], bool vanish);
-  void resetFlag(float position[3], bool teamIsEmpty);
-  void grab(int playerIndex);
-  int  teamIndex() const;
-  int  getIndex() const;
-  bool landing(const TimeKeeper &tm);
-  void getTextualInfo(char *message);
-  bool exist();
+  public:
+    FlagInfo();
 
-  static FlagInfo *get(int index);
-  static void setSize(int _numFlags);
-  static void setAllowed(std::vector<FlagType*> allowed);
-  static void setExtra(int extra);
-  static int  lookupFirstTeamFlag(int teamindex);
-  static float getNextDrop(TimeKeeper &tm);
-  static void  setNoFlagInAir();
+    void setExtraFlag();
+    void setRandomFlag();
+    void setForcedFlag(const FlagType *desc);
+    void addFlag();
+    void dropFlag(float pos[3], float landingPos[3], bool vanish);
+    void resetFlag(const float position[3], bool teamIsEmpty);
+    void grab(int playerIndex);
+    bool landing(const TimeKeeper &tm);
 
-    // flag info
+    void zeroGrabsLeft() { grabsLeft = 0; }
+    void decreaseGrabsLeft() { grabsLeft--; }
+    void increaseShotCount() { shotCount++; }
+    void setOwner(int playerIndex) { flag.owner = playerIndex; }
+    void setPlayer(int playerIndex) { player = playerIndex; }
+    void setStatus(FlagStatus status) { flag.status = status; }
+    void setFlagType(FlagType* type) { flag.type = type; }
+    
+    void* pack(void* buf, bool hide = false);
+
+    void getTextualInfo(char* message) const;
+    
+    inline bool exists() const { return (flag.status != FlagNoExist); }
+    inline bool isZone() const { return (srcZone != NULL); }
+    inline bool isExtra() const { return extra; }
+    inline bool isRandom() const { return random; }
+    inline int getIndex() const { return flagIndex; }
+    inline int getPlayer() const { return player; }
+    inline int getGrabsLeft() const { return grabsLeft; }
+    inline int getShotCount() const { return shotCount; }
+    inline int getTeamIndex() const { return flag.type->flagTeam; }
+    inline const Flag& getFlag() const { return flag; }
+    inline const FlagType* getFlagType() const { return flag.type; }
+    inline const CustomZone* getSourceZone() const { return srcZone; }
+
+  private:
     Flag flag;
-    // player index who has flag
+    int flagIndex;
     int player;
-    // how many grabs before removed
-    int grabs;
-    // true if flag must be in game
-    bool required;
-    // number of shots on this flag
-    int numShots;
+    int grabsLeft; // how many grabs before removed
+    int shotCount; // number of shots on this flag
+    bool extra;    // true if this is an extra slot
+    bool random;   // true if this flag is random
+    const CustomZone* srcZone;
+    TimeKeeper dropDone; // time flag will land
+};
 
-private:
-  int flagIndex;
-  static std::vector<FlagType*> allowedFlags;
-  static int		    numExtraFlags;
-  static int		    numFlags;
-  static int		    numFlagsInAir;
-  static FlagInfo	      *flagList;
 
-  // time flag will land
-  TimeKeeper		    dropDone;
+class FlagManager {
+  public:
+
+    inline int size() const { return fullCount; }
+
+    inline FlagInfo* getFlag(int index);
+
+    void clear();
+    void clearRandomPool();
+    
+    void finalize(); // build the flag list
+
+    void setRandomDelayTimes(float minSeconds, float maxSeconds);
+
+    void setExtraFlags(int count);
+    bool adjustForced(const char* type, int count);
+    bool adjustRandom(const char* type, int count);
+    void setRandomMaximum(int count);
+
+    bool userAdjustForced(const char* type, int count, int playerIndex);
+    bool userAdjustRandom(const char* type, int count, int playerIndex);
+    bool userSetRandomCount(int count, int playerIndex);
+
+    int getZoneCount() const { return zoneCount; }
+    int getExtraCount() const { return extraCount; }
+    int getForcedCount() const { return forcedCount; }
+    int getRandomCount() const { return randomCount; }
+
+    // for client-server flag negotiations
+    void forbidType(const FlagType* ft);
+    bool forbidType(const char* type);
+    bool isAllowedType(const FlagType* ft) const;
+    
+    float getNextDrop(TimeKeeper &tm) const;  // FIXME ?
+
+    void dropFlags();
+    void addRandomFlags(const TimeKeeper& tm);
+    float getNextTime();
+
+    const FlagType* pickRandomFlagType() const; // for FlagInfo
+
+// FIXME - move all the flag type functions here,
+//         dropping, zapping, popping, whatever...
+    void setNoFlagInAir();
+
+//    void resetFlags();
+//    void removeFlags();
+//    void removePlayerFlag(int playerIndex);
+
+//    void addFlag(FlagInfo& fi); 
+//    void zapFlag(FlagInfo& fi);
+//    void dropFlag(FlagInfo& fi, const float pos[3]);
+//    void resetFlag(FlagInfo& fi);
+//    void incShotCount(FlagInfo& fi);
+//    void giveFlag(FlagInfo& fi, int playerIndex);
+
+    void sendFlagInfo(int playerIndex) const;
+    void getFlagList(std::vector<std::string>& text) const;
+    
+    bool identifyFlag() const;
+    int lookupFirstTeamFlag(int teamIndex) const;
+    
+    
+    static FlagType* getTeamFlagType(int);
+
+  private:
+    void adjustTeamFlags(std::set<const FlagType*>& fs, int count);
+    
+    void selectForbidden(); // based on game style, etc...
+    void removeForbidden(std::set<const FlagType*>& fs) const;
+    void removeForbidden(std::map<const FlagType*, int>& fcm) const;
+    void removeTeam(std::set<const FlagType*>& fs) const;
+    
+    static const FlagType* getFlagTypeFromLabel(const char* label);
+    // returned set does not include any forbidden flags
+    // (ft may be one of the fake flag types,  ex: FlagInfo::badFlagType)
+    void getFlagSet(const FlagType* ft, std::set<const FlagType*>& fs) const;
+
+    int getZoneTeamFlagCount(const FlagType*, const EntryZones&) const;
+    int addZoneTeamFlags(int index, const FlagType*, const EntryZones&);
+    
+  private:
+    std::map<const FlagType*, int> randomPool;  // available random counts
+    std::map<const FlagType*, int> randomFlags; // active random flags
+    std::map<const FlagType*, int> forcedFlags; // forced to be active
+    std::set<const FlagType*> forbiddenFlags;   // never present
+
+    FlagInfo* flagList;
+    int fullCount;
+    int zoneCount;
+    int extraCount;
+    int forcedCount;
+    int randomCount;
+    
+    //int numFlagsInAir;
+    
+    bool zoneIdentifyFlag;
+    
+    float minRandomDelay;
+    float maxRandomDelay;
+    TimeKeeper nextRandomInsertion;
+
+    // fake flag types
+    static const FlagType* allFlagType;
+    static const FlagType* badFlagType;
+    static const FlagType* goodFlagType;
+    static const FlagType* teamFlagType;
+
+  private:
+    FlagManager();
+    ~FlagManager();
+    FlagManager(const FlagManager&);
+    FlagManager& operator=(const FlagManager&);
+
+  public:    
+    static FlagManager manager;
 };
-#else
-class FlagInfo;
-#endif
 
+
+#define FLAGMGR (FlagManager::manager)
+
+
+inline FlagInfo* FlagManager::getFlag(int index)
+{
+  if ((index < 0) || (index >= fullCount)) {
+    return NULL;
+  } else {
+    return &flagList[index];
+  }
+}
+
+
+#endif // __FLAGINFO_H__
+
+
 // Local Variables: ***
 // mode:C++ ***
 // tab-width: 8 ***
Index: CmdLineOptions.h
===================================================================
--- CmdLineOptions.h	(revision 20911)
+++ CmdLineOptions.h	(working copy)
@@ -44,8 +44,8 @@
   RandomRabbitSelection		// pick the new rabbit out of a hat
 };
 
-typedef std::map<FlagType*, int> FlagNumberMap;
-typedef std::map<FlagType*,bool> FlagOptionMap;
+typedef std::map<const FlagType*, int> FlagNumberMap;
+typedef std::map<const FlagType*, bool> FlagOptionMap;
 
 #define _DEFAULT_LIN_ACCEL 0.0f
 #define _DEFAULT_ANGLE_ACCELL 0.0f
@@ -56,46 +56,103 @@
 struct CmdLineOptions
 {
   CmdLineOptions()
-  : wksPort(ServerPort), gameStyle(PlainGameStyle),
-    rabbitSelection(ScoreRabbitSelection), msgTimer(0), spamWarnMax(5),
-    servermsg(""), advertisemsg(""), worldFile(""),
-    pingInterface(""), password(""),
-    listServerOverridden(false), publicizedTitle(""), publicizedAddress(""),
-    advertiseGroups("EVERYONE"),
-    suppressMasterBanList(false), masterBanListOverridden(false),
-    maxShots(1), maxTeamScore(0), maxPlayerScore(0),
-    numExtraFlags(0), teamKillerKickRatio(0),
-    numAllowedFlags(0), shakeWins(0), shakeTimeout(0),
-    teamFlagTimeout(30), maxlagwarn(10000), maxjitterwarn(10000), maxpacketlosswarn(10000),
-    adminlagannounce(-1.0), lagannounce(-1.0), lagwarnthresh(-1.0), jitterwarnthresh(-1.0),
-    idlekickthresh(-1.0), timeLimit(0.0f), timeElapsed(0.0f), addedTime(0.0f),
-    linearAcceleration(_DEFAULT_LIN_ACCEL), angularAcceleration(_DEFAULT_ANGLE_ACCELL), useGivenPort(false),
-    useFallbackPort(false), requireUDP(false), randomBoxes(false),
-    randomCTF(false), flagsOnBuildings(false), respawnOnBuildings(false),
-    oneGameOnly(false), timeManualStart(false), randomHeights(false),
-    useTeleporters(false), teamKillerDies(true), printScore(false),
-    publicizeServer(false), replayServer(false), startRecording(false),
-    timestampLog(false), timestampMicros(false),
-    filterFilename(""), filterCallsigns(false), filterChat(false), filterSimple(false),
-    banTime(300), voteTime(60), vetoTime(2), votesRequired(2),
-    votePercentage(50.1f), voteRepeatTime(300),
-    autoTeam(false), citySize(5), cacheURL(""), cacheOut(""), tkAnnounce(false), wallSides(4)
   {
-    int i;
-    for (FlagTypeMap::iterator it = FlagType::getFlagMap().begin();
-	 it != FlagType::getFlagMap().end(); ++it) {
-	flagCount[it->second] = 0;
-	flagLimit[it->second] = -1;
-	flagDisallowed[it->second] = false;
+    const FlagTypeMap& ftm = FlagType::getFlagMap();
+    FlagTypeMap::const_iterator it;
+    for (it = ftm.begin(); it != ftm.end(); it++) {
+      flagLimit[it->second] = -1;
     }
 
-    for (i = 0; i < NumTeams; i++) {
+    for (int i = 0; i < NumTeams; i++) {
       maxTeam[i] = MaxPlayers;
-      numTeamFlags[i] = 0;
     }
 
     listServerURL.push_back(DefaultListServerURL);
     masterBanListURL.push_back(DefaultMasterBanURL);
+
+    listServerOverridden = false;
+    suppressMasterBanList = false;
+    masterBanListOverridden = false;
+
+    wksPort		= ServerPort;
+    useGivenPort	= false;
+    useFallbackPort	= false;
+    requireUDP		= false;
+    pingInterface	= "";
+    
+    gameStyle		= PlainGameStyle;
+    rabbitSelection	= ScoreRabbitSelection;
+    
+    msgTimer		= 0;
+    spamWarnMax		= 5;
+   
+    servermsg		= "";
+    advertisemsg	= "";
+   
+    password		= "";
+    
+    publicizeServer	= false;
+    publicizedTitle	= "";
+    publicizedAddress	= "";
+    advertiseGroups	= "EVERYONE";
+   
+    maxShots		= 1;
+    maxTeamScore	= 0;
+    maxPlayerScore	= 0;
+
+    autoTeam		= false;
+    teamKillerDies	= true;
+    teamKillerKickRatio	= 0;
+   
+    numAllowedFlags	= 0;
+    shakeWins		= 0;
+    shakeTimeout	= 0;
+    teamFlagTimeout	= 30;
+
+    maxlagwarn		= 10000;
+    lagwarnthresh	= -1.0;
+    idlekickthresh	= -1.0;
+
+    timeLimit		= 0.0f;
+    timeElapsed		= 0.0f;
+   
+    worldFile		= "";
+    randomBoxes		= false;
+    randomCTF		= false;
+    randomHeights	= false;
+    useTeleporters	= false;
+    citySize		= 5;
+
+    respawnOnBuildings	= false;
+    flagsOnBuildings	= false;
+    
+    linearAcceleration	= _DEFAULT_LIN_ACCEL;
+    angularAcceleration	= _DEFAULT_ANGLE_ACCELL;
+   
+    oneGameOnly		= false;
+    timeManualStart	= false;
+
+    replayServer	= false;
+    startRecording	= false;
+   
+    printScore		= false;
+    timestampLog	= false;
+    timestampMicros	= false;
+   
+    filterFilename	= "";
+    filterCallsigns	= false;
+    filterChat		= false;
+    filterSimple	= false;
+   
+    banTime		= 300;
+    voteTime		= 60;
+    vetoTime		= 2;
+    votesRequired	= 2;
+    votePercentage	= 50.1f;
+    voteRepeatTime	= 300;
+
+    cacheURL		= "";
+    cacheOut		= "";
   }
 
   int			wksPort;
@@ -104,27 +161,26 @@
   int			msgTimer;
   int			spamWarnMax;
 
-  std::string   servermsg;
-  std::string   advertisemsg;
-  std::string   worldFile;
-  std::string   pingInterface;
-  std::string   password;
+  std::string   	servermsg;
+  std::string   	advertisemsg;
+  std::string   	worldFile;
+  std::string   	pingInterface;
+  std::string   	password;
 
-  bool listServerOverridden;
+  bool			listServerOverridden;
   std::vector<std::string>   listServerURL;
 
-  std::string	publicizedTitle;
-  std::string	publicizedAddress;
-  std::string	advertiseGroups;
+  std::string		publicizedTitle;
+  std::string		publicizedAddress;
+  std::string		advertiseGroups;
 
   bool			suppressMasterBanList;
   bool			masterBanListOverridden;
-  std::vector<std::string>		masterBanListURL;
+  std::vector<std::string>	masterBanListURL;
 
   uint16_t		maxShots;
   int			maxTeamScore;
   int			maxPlayerScore;
-  int			numExtraFlags;
   int			teamKillerKickRatio; // if players tk*100/wins > teamKillerKickRatio -> kicked
   int			numAllowedFlags;
   uint16_t		shakeWins;
@@ -167,9 +223,7 @@
   bool			countdownPaused;
 
   uint16_t		maxTeam[NumTeams];
-  FlagNumberMap		flagCount;
   FlagNumberMap		flagLimit; // # shots allowed / flag
-  FlagOptionMap		flagDisallowed;
 
   AccessControlList	acl;
   TextChunkManager	textChunker;
@@ -182,12 +236,12 @@
   WordFilter		filter;
 
   /* vote poll options */
-  unsigned short int banTime;
-  unsigned short int voteTime;
-  unsigned short int vetoTime;
-  unsigned short int votesRequired;
-  float votePercentage;
-  unsigned short int voteRepeatTime;
+  unsigned short int	banTime;
+  unsigned short int	voteTime;
+  unsigned short int	vetoTime;
+  unsigned short int	votesRequired;
+  float 		votePercentage;
+  unsigned short int	voteRepeatTime;
 
   std::string		reportFile;
   std::string		reportPipe;
@@ -199,33 +253,31 @@
 
   /* city options */
   int			citySize;
-  int			numTeamFlags[NumTeams];
 
-  std::string	   cacheURL;
-  std::string	   cacheOut;
+  std::string		cacheURL;
+  std::string		cacheOut;
 
   bool			tkAnnounce;
   int			wallSides;
 
   // plugins
-  typedef struct
-  {
-	  std::string plugin;
-	  std::string command;
-  }pluginDef;
+  typedef struct {
+    std::string plugin;
+    std::string command;
+  } pluginDef;
 
   std::vector<pluginDef>	pluginList;
 };
 
 
 void parse(int argc, char **argv, CmdLineOptions &options, bool fromWorldFile = false);
-void finalizeParsing(int argc, char **argv, CmdLineOptions &options, EntryZones& ez);
+void finalizeParsing(int argc, char **argv, CmdLineOptions &options);
 bool checkCommaList (const char *list, int maxlen);
 
-#else
-struct CmdLineOptions;
-#endif
 
+#endif // __CMDLINEOPTIONS_H__
+
+
 // Local Variables: ***
 // mode:C++ ***
 // tab-width: 8 ***
Index: SpawnPolicy.cxx
===================================================================
--- SpawnPolicy.cxx	(revision 20911)
+++ SpawnPolicy.cxx	(working copy)
@@ -210,8 +210,8 @@
       float  enemyAngle = playerData->lastState.azimuth;
       if (playerData->player.getFlag() >= 0) {
 	// check for dangerous flags
-	const FlagInfo *finfo = FlagInfo::get(playerData->player.getFlag());
-	const FlagType *ftype = finfo->flag.type;
+	const FlagInfo *finfo = FLAGMGR.getFlag(playerData->player.getFlag());
+	const FlagType *ftype = finfo->getFlagType();
 	// FIXME: any more?
 	if (ftype == Flags::Laser) {  // don't spawn in the line of sight of an L
 	  if (isFacing(enemyPos, enemyAngle, twentyDegrees)) { // he's looking within 20 degrees of spawn point
